package org.jcg.zheng;

import static org.junit.Assert.assertEquals;

import java.math.BigDecimal;
import java.math.RoundingMode;

import org.junit.Test;

public class BigDecimalRoundTest {

    private static final double TEST_DOUBLE = 0.56679;

    @Test
    public void test_round_2() {
        BigDecimal bigDec = BigDecimal.valueOf(TEST_DOUBLE);

        System.out.println("original double: " + TEST_DOUBLE);

        for (RoundingMode rm : RoundingMode.values()) {
            System.out.print("\tRoundingMode=" + rm.name());
            try {
                double roundValue = bigDec.setScale(2, rm).doubleValue();

                assertEquals(TEST_DOUBLE, roundValue, 0.01);

                System.out.println("\t With 2 decimal places: " + roundValue);
            } catch (ArithmeticException ae) {
                System.out.println("Caught exception for " + rm.name());
            }
        }
    }

    @Test
    public void test_round_2and3() {
        BigDecimal bigDec = BigDecimal.valueOf(TEST_DOUBLE);

        double round2 = bigDec.setScale(2, BigDecimal.ROUND_CEILING).doubleValue();

        double round3 = bigDec.setScale(3, BigDecimal.ROUND_CEILING).doubleValue();

        assertEquals(0.57, round2, 0.01);
        assertEquals(0.567, round3, 0.001);
    }

}
