package org.jcg.zheng;

import static org.junit.Assert.assertEquals;

import java.math.RoundingMode;
import java.text.DecimalFormat;

import org.junit.Test;

public class DecimalFormatTest {

    private final String TWO_DECIMAL_FORMAT_PAD_ZERO_AFTER = "#.00";
    private final String TWO_DECIMAL_FORMAT_PAD_ZERO_BEFORE = "0.##";
    private final String TWO_DECIMAL_FORMAT_NOT_PAD = "#.##";
    private final String TWO_DECIMAL_FORMAT_PAD_ZERO = "0.00";

    public String[] TWO_PLACES_FORMATS = { TWO_DECIMAL_FORMAT_PAD_ZERO_AFTER,
        TWO_DECIMAL_FORMAT_PAD_ZERO_BEFORE, TWO_DECIMAL_FORMAT_NOT_PAD,
        TWO_DECIMAL_FORMAT_PAD_ZERO };

    @Test
    public void test_DecimalFormat() {
        for (double testDouble : TestConstants.TEST_DOUBLES) {
            for (String decimalFormat : TWO_PLACES_FORMATS) {
                DecimalFormat df = new DecimalFormat(decimalFormat);
                for (RoundingMode rm : RoundingMode.values()) {
                    if (!RoundingMode.UNNECESSARY.equals(rm)) {
                        df.setRoundingMode(rm);
                        double roundedValue = Double.valueOf(df.format(testDouble));
                        assertEquals(testDouble, roundedValue, 0.01);
                        printDouble(testDouble, df.format(testDouble), rm, decimalFormat);
                    }
                }
            }
        }
    }

    private void printDouble(double testDouble, String rounded, RoundingMode rm,
            String decimalFormat) {
        System.out.println("Original=" + testDouble + " Rounded with \"" + decimalFormat + "\" "
                + rm.name() + " =" + rounded);
    }

}
