package org.jcg.zheng;

import static org.junit.Assert.assertEquals;

import java.math.RoundingMode;
import java.text.NumberFormat;
import java.util.stream.DoubleStream;
import java.util.stream.Stream;

import org.junit.Test;

public class NumberFormatTest {

    private DoubleStream doubleStream = DoubleStream.of(-123.345, 0.4, 0.446, 124, 124.56679);

    @Test
    public void test_NumberFormat_format() {
        NumberFormat nf = NumberFormat.getInstance();
        nf.setMaximumFractionDigits(2);
        nf.setMinimumFractionDigits(2);

        doubleStream.forEach(testDouble -> {
            Stream.of(RoundingMode.values()).forEach(roundingMode -> {
                nf.setRoundingMode(roundingMode);
                System.out.print("Original double:" + testDouble);
                try {
                    double roundedDouble = Double.valueOf(nf.format(testDouble));

                    assertEquals(testDouble, roundedDouble, 0.01);

                    System.out.println(
                            " " + roundingMode.name() + ", formatted double:" + roundedDouble);
                } catch (Exception e) {
                    System.out.println(
                            " " + roundingMode.name() + "Caught exception" + e.getMessage());
                }

            });
        });

    }

}
